clear all
close all
clc

%% load data


File = ['D:\Sectors\Clean\Data_cycle\Data.xls'];
u = xlsread(File,1,'C58:C81'); %unemployment
y = xlsread(File,1,'G58:G81'); %output per worker
w = xlsread(File,1,'H58:H81'); %wages
labor_sh = xlsread(File,1,'B58:B81'); %labor share
time = 1996:1:2019;



%HP filter
[~,u] = hpfilter(u./100,Smoothing=100);
[~,y] = hpfilter(log(y),Smoothing=100);
[~,w] = hpfilter(log(w),Smoothing=100);
[~,labor_sh] = hpfilter(labor_sh./100,Smoothing=100);



%labor productivity and wages
figure(1)
plot(time,y,'LineWidth',2.5,'Color',[0 0 1])
hold on
plot(time,w,'LineWidth',2.5,'LineStyle','--','Color',[1 0 0])
hold off
legend('Labor productivity','Wages','FontSize',13)
ax = gca;
ax.FontSize = 16; 
xlabel('Year','fontsize',16)
ylabel('Deviation from trend','fontsize',16)
width=350;
height=350;

%labor productivity and labor share
figure(2)
plot(time,y,'LineWidth',2.5,'Color',[0 0 1])
hold on
plot(time,labor_sh*100,'LineWidth',2.5,'LineStyle','--','Color',[1 0 0])
hold off
legend('Labor productivity','Labor share*100','FontSize',13)
ax = gca;
ax.FontSize = 16; 
xlabel('Year','fontsize',16)
ylabel('Deviation from trend','fontsize',16)
width=350;
height=350;

