#include "fintrf.h"

!----------------------------------------------------------------------------
! Gateway routine
!----------------------------------------------------------------------------

subroutine mexFunction(nlhs,plhs,nrhs,prhs)
    implicit none
    
    ! Arguments in mexFunction
      mwPointer  :: plhs(*), prhs(*)
      integer    :: nlhs, nrhs
    
    ! Function declarations
      mwPointer     mxCreateNumericArray ,mxGetPr, mxGetM, mxGetN
      mwPointer     mxGetDimensions, mxCreateDoubleMatrix
      integer(4)    mxClassIDFromClassName
      mwSize        mxGetNumberOfDimensions
      
      ! Pointers to input/output mxArrays:
      ! Input           
      mwPointer  :: panel_in,H,TEND,TR,N_x,N_xi,N_pr,die,offer,offer_type_p &
                    ,destruct,tran_xi,skill_acc,shock_pr_new,shock_pr,xi_prob,prob_pr_birth &
                    ,mu,p_e,varphi,delta,Pxi_tran,w_H,w_W &
                    ,p_W_U,p_H_U,p_H_RH,p_W_RH,p_W_RW,p_H_RW &
                    ,pol_U_HW,pol_U_W,pol_F_fill_W,pol_U_H,pol_F_fill_H &
                    ,pol_F_H_N,pol_F_RH_U,pol_F_W_N,pol_F_RW_U &
                    ,pol_RH_s,pol_RH_H,pol_F_RH_H,pol_RH_W,pol_RW_s &
                    ,pol_RW_W,pol_F_RW_W,pol_RW_H

       ! Output
      mwPointer  :: panel
      
    ! Array size information
      integer(4) :: Nx,Ny,complexFlag,classid,classid2    ! length of input (output) array
      mwSize     :: ndim
      mwSize     :: dims(3)                      ! dimensions (for mxCreateNumericArray)
!--------------------------------------------------------------------------------    
      !size of output vector
      ndim = mxGetNumberOfDimensions(prhs(1))
      
      ! Retrieve size of input arguments (also size of output argument)
      call mxCopyPtrToPtrArray(mxGetDimensions(prhs(1)), dims, mxGetNumberOfDimensions(prhs(1)))
      Nx = maxval(dims)
	  
      classid = mxClassIDFromClassName('double')
      complexFlag = 0   

      
      
      ! Retrieve input parameter pointers
      panel_in = mxGetPr(prhs(1))
      H = mxGetPr(prhs(2))
      TEND = mxGetPr(prhs(3))
      TR = mxGetPr(prhs(4))
      N_x = mxGetPr(prhs(5))
      N_xi = mxGetPr(prhs(6))
      N_pr = mxGetPr(prhs(7))
      
      die = mxGetPr(prhs(8))
      offer = mxGetPr(prhs(9))
      offer_type_p = mxGetPr(prhs(10))
      destruct = mxGetPr(prhs(11))
      tran_xi = mxGetPr(prhs(12))
      skill_acc = mxGetPr(prhs(13))
      shock_pr_new = mxGetPr(prhs(14))
      shock_pr = mxGetPr(prhs(15))
      xi_prob = mxGetPr(prhs(16))
      prob_pr_birth = mxGetPr(prhs(17))
      
      mu = mxGetPr(prhs(18))
      p_e = mxGetPr(prhs(19))
      varphi = mxGetPr(prhs(20))
      
      delta = mxGetPr(prhs(21))
      Pxi_tran = mxGetPr(prhs(22))
      w_H = mxGetPr(prhs(23))
      w_W = mxGetPr(prhs(24))
      
      p_W_U = mxGetPr(prhs(25))
      p_H_U = mxGetPr(prhs(26))
      p_H_RH = mxGetPr(prhs(27))
      p_W_RH = mxGetPr(prhs(28))
      p_W_RW = mxGetPr(prhs(29))
      p_H_RW = mxGetPr(prhs(30))

      
      pol_U_HW = mxGetPr(prhs(31))
      pol_U_W = mxGetPr(prhs(32))
      pol_F_fill_W = mxGetPr(prhs(33))
      pol_U_H = mxGetPr(prhs(34))
      pol_F_fill_H = mxGetPr(prhs(35))
      pol_F_H_N = mxGetPr(prhs(36))
      pol_F_RH_U = mxGetPr(prhs(37))
      pol_F_W_N = mxGetPr(prhs(38))
      pol_F_RW_U = mxGetPr(prhs(39))
      pol_RH_s = mxGetPr(prhs(40))
      pol_RH_H = mxGetPr(prhs(41))
      pol_F_RH_H = mxGetPr(prhs(42))
      pol_RH_W = mxGetPr(prhs(43))
      pol_RW_s = mxGetPr(prhs(44))
      pol_RW_W = mxGetPr(prhs(45))
      pol_F_RW_W = mxGetPr(prhs(46))
      pol_RW_H = mxGetPr(prhs(47))

      


     ! Create matrices for return arguments

     plhs(1) = mxCreateNumericArray(ndim, dims, classid, complexflag)

 
     panel = mxGetPr(plhs(1))


!call computation function
	  call sub_val_fun(%val(panel),%val(panel_in),%val(H),%val(TEND),%val(TR),%val(N_x) &
          ,%val(N_xi),%val(N_pr) &
          ,%val(die),%val(offer),%val(offer_type_p),%val(destruct),%val(tran_xi),%val(skill_acc) &
          ,%val(shock_pr_new),%val(shock_pr),%val(xi_prob),%val(prob_pr_birth) &
          ,%val(mu),%val(p_e),%val(varphi),%val(delta),%val(Pxi_tran),%val(w_H),%val(w_W) &
          ,%val(p_W_U),%val(p_H_U),%val(p_H_RH),%val(p_W_RH),%val(p_W_RW),%val(p_H_RW) &
          ,%val(pol_U_HW),%val(pol_U_W),%val(pol_F_fill_W),%val(pol_U_H),%val(pol_F_fill_H) &
          ,%val(pol_F_H_N),%val(pol_F_RH_U),%val(pol_F_W_N),%val(pol_F_RW_U) &
          ,%val(pol_RH_s),%val(pol_RH_H),%val(pol_F_RH_H),%val(pol_RH_W),%val(pol_RW_s) &
          ,%val(pol_RW_W),%val(pol_F_RW_W),%val(pol_RW_H))
								  
        
      return  
      
end subroutine



subroutine sub_val_fun(panel,panel_in,H,TEND,TR,N_x,N_xi,N_pr,die,offer,offer_type_p &
                    ,destruct,tran_xi,skill_acc,shock_pr_new,shock_pr,xi_prob,prob_pr_birth &
                    ,mu,p_e,varphi,delta,Pxi_tran,w_H,w_W &
                    ,p_W_U,p_H_U,p_H_RH,p_W_RH,p_W_RW,p_H_RW &
                    ,pol_U_HW,pol_U_W,pol_F_fill_W,pol_U_H,pol_F_fill_H &
                    ,pol_F_H_N,pol_F_RH_U,pol_F_W_N,pol_F_RW_U &
                    ,pol_RH_s,pol_RH_H,pol_F_RH_H,pol_RH_W,pol_RW_s &
                    ,pol_RW_W,pol_F_RW_W,pol_RW_H)

implicit none

integer(4), intent(in)					       :: H,TEND,TR,N_x,N_xi,N_pr
real(8), dimension(H,10,TEND+1), intent(in)        :: panel_in
real(8), intent(in)							   :: mu,p_e,varphi
real(8), dimension(2), intent(in)              :: delta
real(8), dimension(N_xi,N_xi), intent(in)      :: Pxi_tran
real(8), dimension(N_x,N_x,N_xi,2), intent(in)   :: w_H,w_W
real(8), dimension(H,TEND), intent(in)            :: die,offer,offer_type_p,destruct,tran_xi,skill_acc
real(8), dimension(H,TEND), intent(in)            :: shock_pr_new,shock_pr
real(8), dimension(N_xi), intent(in)           :: xi_prob
real(8), dimension(N_pr), intent(in)           :: prob_pr_birth
real(8), dimension(N_x,N_x,N_pr,TEND+1), intent(in)      :: p_W_U,p_H_U
real(8), dimension(N_x,N_x,N_xi,N_pr,TEND+1), intent(in)    :: p_H_RH,p_W_RH,p_W_RW,p_H_RW
integer(4), dimension(N_x,N_x,N_pr,TEND+1), intent(in)      :: pol_U_HW
integer(4), dimension(N_x,N_x,N_xi,N_pr,TEND+1), intent(in)  :: pol_U_W,pol_F_fill_W,pol_U_H,pol_F_fill_H
integer(4), dimension(N_x,N_x,N_xi,N_pr,TEND+1), intent(in)  :: pol_F_H_N,pol_F_RH_U,pol_F_W_N,pol_F_RW_U
integer(4), dimension(N_x,N_x,N_xi,N_pr,TEND+1), intent(in)  :: pol_RH_s,pol_F_RH_H,pol_RW_s,pol_F_RW_W
integer(4), dimension(N_x,N_x,N_xi,N_pr,N_xi,TEND+1), intent(in)  :: pol_RH_H,pol_RH_W,pol_RW_W,pol_RW_H



real(8), dimension(H,10,TEND+1), intent(out)        :: panel


!define further variables
integer(4)                     :: i1,t1,pos_pr_ini,offer_type,next_xi,bc,count_H
integer(4)                     :: sticky, wage_s
real(8), dimension(N_xi)       :: xi_prob_cum, xi_aux
real(8), dimension(N_pr)        :: prob_pr_birth_cum
character*120            :: line
real(8)                  :: xxx


!call sub_mexWriteString('head works')

sticky = 0 !number of periods with wage in good state 10

call cumsum(xi_prob,xi_prob_cum,N_xi)
call cumsum(prob_pr_birth,prob_pr_birth_cum,N_pr)

!write(line,*) "xxx = ",p_W_U(2,2,7)
!call sub_mexWriteString(line)

panel(:,:,1) = panel_in(:,:,1)

!call sub_mexWriteString('initialization works')

count_H = H

do t1 = 1,TEND !loop over time

    
    if (t1<sticky) then !wage from good state
        wage_s = 1
    elseif (t1==1) then !initial period
        wage_s = 1
    elseif (t1>TR) then
        wage_s = 1
    else
        wage_s = 2
    end if
    
    do i1 = 1,H !loop over individuals
        !if (panel(i1,9,t1) == 1) then !allive
        panel(i1,9,t1) = t1
            if (panel(i1,2,t1) == 0) then !unemployed
                if (die(i1,t1)>mu) then !survives
                    panel(i1,1,t1+1) = panel(i1,1,t1)
                    panel(i1,8,t1+1) = panel(i1,8,t1)
                    if (pol_U_HW(panel(i1,3,t1),panel(i1,4,t1),panel(i1,8,t1),t1) == 0) then !search in W
                        panel(i1,10,t1) = 2.d0
                        if (offer(i1,t1)<p_W_U(panel(i1,3,t1),panel(i1,4,t1),panel(i1,8,t1),t1)) then !receives an offer
                            call find_pos(xi_prob_cum,offer_type_p(i1,t1),offer_type,N_xi)
                            offer_type = offer_type+1
                            if (((pol_U_W(panel(i1,3,t1),panel(i1,4,t1),offer_type,panel(i1,8,t1),t1) == 1) .and. & 
                                (pol_F_fill_W(panel(i1,3,t1),panel(i1,4,t1),offer_type,panel(i1,8,t1),t1) == 1))) then !accepts the offer and firm fills the vacancy
                                panel(i1,2,t1+1) = 2.d0 !employed in W
                                xi_aux = Pxi_tran(offer_type,:)
                                call find_pos(xi_aux,tran_xi(i1,t1),next_xi,N_xi)
                                panel(i1,5,t1+1) = next_xi+1
                                panel(i1,7,t1) = 1.d0 !switched employers
                            else !reject offer
                                panel(i1,2,t1+1) = 0.d0
                                panel(i1,5,t1+1) = 0.d0
                            end if
                        else !no offer
                            panel(i1,2,t1+1) = 0.d0
                            panel(i1,5,t1+1) = 0.d0
                        end if
                    else !search in H
                        panel(i1,10,t1) = 1.d0
                        if (offer(i1,t1)<p_H_U(panel(i1,3,t1),panel(i1,4,t1),panel(i1,8,t1),t1)) then !receives an offer
                            call find_pos(xi_prob_cum,offer_type_p(i1,t1),offer_type,N_xi)
                            offer_type = offer_type+1
                            if ((pol_U_H(panel(i1,3,t1),panel(i1,4,t1),offer_type,panel(i1,8,t1),t1) == 1) .and. &
                                (pol_F_fill_H(panel(i1,3,t1),panel(i1,4,t1),offer_type,panel(i1,8,t1),t1) == 1)) then !accepts the offer and firm fills the vacancy
                                panel(i1,2,t1+1) = 1.d0 !employed in H
                                xi_aux = Pxi_tran(offer_type,:)
                                call find_pos(xi_aux,tran_xi(i1,t1),next_xi,N_xi)
                                panel(i1,5,t1+1) = next_xi+1
                                panel(i1,7,t1) = 1.d0
                            else !reject offer
                                panel(i1,2,t1+1) = 0.d0
                                panel(i1,5,t1+1) = 0.d0
                            end if
                        else !no offer
                            panel(i1,2,t1+1) = 0.d0
                            panel(i1,5,t1+1) = 0.d0
                        end if
                    end if
                    !no skill depreciation
                    panel(i1,3,t1+1) = panel(i1,3,t1)
                    panel(i1,4,t1+1) = panel(i1,4,t1)
                else !dies (reborn as unemployed)
                    count_H = count_H+1
                    panel(i1,1,t1+1) = count_H
                    panel(i1,2,t1+1) = 0.d0 !all start unemployed
                    !panel(i1,9,t1+1) = 1.d0 !all start allive
                    panel(i1,3,t1+1) = 1 !zero skills
                    panel(i1,4,t1+1) = 1
                    call find_pos(prob_pr_birth_cum,shock_pr(i1,t1),pos_pr_ini,N_pr)
                    pos_pr_ini = pos_pr_ini+1
                    panel(i1,8,t1+1) = pos_pr_ini
                end if
            elseif (panel(i1,2,t1) == 1) then !employed H
                panel(i1,6,t1) = w_H(panel(i1,3,t1),panel(i1,4,t1),panel(i1,5,t1),wage_s)
                if (die(i1,t1)>mu) then !survives
                    !panel(i1,9,t1+1) = 1.d0
                    panel(i1,1,t1+1) = panel(i1,1,t1)
                    panel(i1,8,t1+1) = panel(i1,8,t1)
                    if (skill_acc(i1,t1)<=p_e) then !skill appreciation
                        panel(i1,3,t1+1) = min(panel(i1,3,t1)+1,real(N_x))
                    else
                        panel(i1,3,t1+1) = panel(i1,3,t1)
                    end if
                    panel(i1,4,t1+1) = panel(i1,4,t1) !no skill depreciation
                    if ((destruct(i1,t1) < delta(1))) then
                        panel(i1,2,t1+1) = 0.d0 !become unemployed
                        panel(i1,5,t1+1) = 0.d0
                        if (shock_pr_new(i1,t1)<=varphi) then !new preferences
                            call find_pos(prob_pr_birth_cum,shock_pr(i1,t1),pos_pr_ini,N_pr)
                            pos_pr_ini = pos_pr_ini+1
                            panel(i1,8,t1+1) = pos_pr_ini
                        end if
                    else !stay employed
                        if (pol_F_H_N(panel(i1,3,t1),panel(i1,4,t1),panel(i1,5,t1),panel(i1,8,t1),t1)==1) then !firm does not choose employment
                            if (pol_F_RH_U(panel(i1,3,t1),panel(i1,4,t1),panel(i1,5,t1),panel(i1,8,t1),t1)==1) then !worker is fired
                                panel(i1,2,t1+1) = 0.d0
                                panel(i1,5,t1+1) = 0.d0
                                if (shock_pr_new(i1,t1)<=varphi) then !new preferences
                                    call find_pos(prob_pr_birth_cum,shock_pr(i1,t1),pos_pr_ini,N_pr)
                                    pos_pr_ini = pos_pr_ini+1
                                    panel(i1,8,t1+1) = pos_pr_ini
                                end if
                            else !worker send to ERTE
                                panel(i1,2,t1+1) = 3.d0
                                xi_aux = Pxi_tran(panel(i1,5,t1),:)
                                call find_pos(xi_aux,tran_xi(i1,t1),next_xi,N_xi)
                                panel(i1,5,t1+1) = next_xi+1
                            end if
                        else !stay employed
                            panel(i1,2,t1+1) = 1.d0
                            xi_aux = Pxi_tran(panel(i1,5,t1),:)
                            call find_pos(xi_aux,tran_xi(i1,t1),next_xi,N_xi)
                            panel(i1,5,t1+1) = next_xi+1
                        end if
                    end if
                else !dies (reborn as unemployed)
                    count_H = count_H+1
                    panel(i1,1,t1+1) = count_H
                    panel(i1,2,t1+1) = 0.d0 !all start unemployed
                    !panel(i1,9,t1+1) = 1.d0 !all start allive
                    panel(i1,3,t1+1) = 1 !zero skills
                    panel(i1,4,t1+1) = 1
                    call find_pos(prob_pr_birth_cum,shock_pr(i1,t1),pos_pr_ini,N_pr)
                    pos_pr_ini = pos_pr_ini+1
                    panel(i1,8,t1+1) = pos_pr_ini
                end if
                
            elseif (panel(i1,2,t1) == 2) then !employed W
                panel(i1,6,t1) = w_W(panel(i1,3,t1),panel(i1,4,t1),panel(i1,5,t1),wage_s)
                if (die(i1,t1)>mu) then !survives
                    !panel(i1,9,t1+1) = 1.d0
                    panel(i1,1,t1+1) = panel(i1,1,t1)
                    panel(i1,8,t1+1) = panel(i1,8,t1)
                    if (skill_acc(i1,t1)<=p_e) then !skill appreciation
                        panel(i1,4,t1+1) = min(panel(i1,4,t1)+1,real(N_x)) 
                    else
                        panel(i1,4,t1+1) = panel(i1,4,t1)
                    end if
                    panel(i1,3,t1+1) = panel(i1,3,t1) !no skill depreciation
                    if ((destruct(i1,t1) < delta(2))) then
                        panel(i1,2,t1+1) = 0.d0 !become unemployed
                        panel(i1,5,t1+1) = 0.d0
                        if (shock_pr_new(i1,t1)<=varphi) then !new preferences
                            call find_pos(prob_pr_birth_cum,shock_pr(i1,t1),pos_pr_ini,N_pr)
                            pos_pr_ini = pos_pr_ini+1
                            panel(i1,8,t1+1) = pos_pr_ini
                        end if
                    else !stay employed
                        if (pol_F_W_N(panel(i1,3,t1),panel(i1,4,t1),panel(i1,5,t1),panel(i1,8,t1),t1)==1) then !firm does not choose employment
                            if (pol_F_RW_U(panel(i1,3,t1),panel(i1,4,t1),panel(i1,5,t1),panel(i1,8,t1),t1)==1) then !worker is fired
                                panel(i1,2,t1+1) = 0.d0
                                panel(i1,5,t1+1) = 0.d0
                                if (shock_pr_new(i1,t1)<=varphi) then !new preferences
                                    call find_pos(prob_pr_birth_cum,shock_pr(i1,t1),pos_pr_ini,N_pr)
                                    pos_pr_ini = pos_pr_ini+1
                                    panel(i1,8,t1+1) = pos_pr_ini
                                end if
                            else !worker send to ERTE
                                panel(i1,2,t1+1) = 4.d0
                                xi_aux = Pxi_tran(panel(i1,5,t1),:)
                                call find_pos(xi_aux,tran_xi(i1,t1),next_xi,N_xi)
                                panel(i1,5,t1+1) = next_xi+1
                            end if
                        else !stay employed
                            panel(i1,2,t1+1) = 2.d0
                            xi_aux = Pxi_tran(panel(i1,5,t1),:)
                            call find_pos(xi_aux,tran_xi(i1,t1),next_xi,N_xi)
                            panel(i1,5,t1+1) = next_xi+1
                        end if
                    end if
                else !dies (reborn as unemployed)
                    count_H = count_H+1
                    panel(i1,1,t1+1) = count_H
                    panel(i1,2,t1+1) = 0.d0 !all start unemployed
                    !panel(i1,9,t1+1) = 1.d0 !all start allive
                    panel(i1,3,t1+1) = 1 !zero skills
                    panel(i1,4,t1+1) = 1
                    call find_pos(prob_pr_birth_cum,shock_pr(i1,t1),pos_pr_ini,N_pr)
                    pos_pr_ini = pos_pr_ini+1
                    panel(i1,8,t1+1) = pos_pr_ini 
                end if
                
            elseif (panel(i1,2,t1) == 3) then !ERTE in H
                !no skill depreciation
                panel(i1,3,t1+1) = panel(i1,3,t1)
                panel(i1,4,t1+1) = panel(i1,4,t1)
                if (die(i1,t1)>mu) then !survives
                    !panel(i1,9,t1+1) = 1.d0
                    panel(i1,1,t1+1) = panel(i1,1,t1)
                    panel(i1,8,t1+1) = panel(i1,8,t1)
                    if (destruct(i1,t1) < delta(1)) then !exogenous job destruction 
                        panel(i1,2,t1+1) = 0.d0 !become unemployed
                        panel(i1,5,t1+1) = 0.d0
                        call find_pos(prob_pr_birth_cum,shock_pr(i1,t1),pos_pr_ini,N_pr)
                        pos_pr_ini = pos_pr_ini+1
                        panel(i1,8,t1+1) = pos_pr_ini 
                    else !not exogenous destroyed 
                        if (pol_RH_s(panel(i1,3,t1),panel(i1,4,t1),panel(i1,5,t1),panel(i1,8,t1),t1)==1) then !worker searches in H
                            panel(i1,10,t1) = 1.d0
                            if (offer(i1,t1)<p_H_RH(panel(i1,3,t1),panel(i1,4,t1),panel(i1,5,t1),panel(i1,8,t1),t1)) then !job offer
                                call find_pos(xi_prob_cum,offer_type_p(i1,t1),offer_type,N_xi)
                                offer_type = offer_type+1
                                if ((pol_RH_H(panel(i1,3,t1),panel(i1,4,t1),panel(i1,5,t1),panel(i1,8,t1),offer_type,t1)==1) .and. &
                                    (pol_F_fill_H(panel(i1,3,t1),panel(i1,4,t1),offer_type,panel(i1,8,t1),t1) == 1)) then !accepts outside offer and firm fills it
                                    panel(i1,2,t1+1) = 1.d0 !H in next period
                                    xi_aux = Pxi_tran(offer_type,:)
                                    call find_pos(xi_aux,tran_xi(i1,t1),next_xi,N_xi)
                                    panel(i1,5,t1+1) = next_xi+1
                                    panel(i1,7,t1) = 1.d0 !switched employers
                                else !stays on current ERTE
                                    xi_aux = Pxi_tran(panel(i1,5,t1),:)
                                    call find_pos(xi_aux,tran_xi(i1,t1),next_xi,N_xi)
                                    panel(i1,5,t1+1) = next_xi+1
                                    if (pol_F_RH_H(panel(i1,3,t1),panel(i1,4,t1),panel(i1,5,t1),panel(i1,8,t1),t1)==0) then !firm does not recall worker
                                        panel(i1,2,t1+1) = 3.d0
                                    else !recalled
                                        panel(i1,2,t1+1) = 1.d0
                                    end if
                                end if
                            else !no job offer
                                xi_aux = Pxi_tran(panel(i1,5,t1),:)
                                call find_pos(xi_aux,tran_xi(i1,t1),next_xi,N_xi)
                                panel(i1,5,t1+1) = next_xi+1
                                if (pol_F_RH_H(panel(i1,3,t1),panel(i1,4,t1),panel(i1,5,t1),panel(i1,8,t1),t1)==0) then !firm does not recall worker
                                    panel(i1,2,t1+1) = 3.d0
                                else !recalled
                                    panel(i1,2,t1+1) = 1.d0
                                end if
                            end if
                        else !worker searches in W
                            panel(i1,10,t1) = 2.d0
                            if (offer(i1,t1)<p_W_RH(panel(i1,3,t1),panel(i1,4,t1),panel(i1,5,t1),panel(i1,8,t1),t1)) then !job offer
                                call find_pos(xi_prob_cum,offer_type_p(i1,t1),offer_type,N_xi)
                                offer_type = offer_type+1
                                if ((pol_RH_W(panel(i1,3,t1),panel(i1,4,t1),panel(i1,5,t1),panel(i1,8,t1),offer_type,t1)==1) .and. &
                                    (pol_F_fill_W(panel(i1,3,t1),panel(i1,4,t1),offer_type,panel(i1,8,t1),t1) == 1)) then !accepts outside offer and firm fills it
                                    panel(i1,2,t1+1) = 2.d0 !become employed
                                    xi_aux = Pxi_tran(offer_type,:)
                                    call find_pos(xi_aux,tran_xi(i1,t1),next_xi,N_xi)
                                    panel(i1,5,t1+1) = next_xi+1
                                    panel(i1,7,t1) = 1.d0
                                else !stays on current ERTE
                                    xi_aux = Pxi_tran(panel(i1,5,t1),:)
                                    call find_pos(xi_aux,tran_xi(i1,t1),next_xi,N_xi)
                                    panel(i1,5,t1+1) = next_xi+1
                                    if (pol_F_RH_H(panel(i1,3,t1),panel(i1,4,t1),panel(i1,5,t1),panel(i1,8,t1),t1)==0) then !firm does not recall worker
                                        panel(i1,2,t1+1) = 3.d0
                                    else !recalled
                                        panel(i1,2,t1+1) = 1.d0
                                    end if
                                end if
                            else !no job offer
                                xi_aux = Pxi_tran(panel(i1,5,t1),:)
                                call find_pos(xi_aux,tran_xi(i1,t1),next_xi,N_xi)
                                panel(i1,5,t1+1) = next_xi+1
                                if (pol_F_RH_H(panel(i1,3,t1),panel(i1,4,t1),panel(i1,5,t1),panel(i1,8,t1),t1)==0) then !firm does not recall worker
                                    panel(i1,2,t1+1) = 3.d0
                                else !recalled
                                    panel(i1,2,t1+1) = 1.d0
                                end if
                            end if
                        end if
                        
                    end if
                else !dies (reborn as unemployed)
                    count_H = count_H+1
                    panel(i1,1,t1+1) = count_H
                    panel(i1,2,t1+1) = 0.d0 !all start unemployed
                    !panel(i1,9,t1+1) = 1.d0 !all start allive
                    panel(i1,3,t1+1) = 1 !zero skills
                    panel(i1,4,t1+1) = 1
                    call find_pos(prob_pr_birth_cum,shock_pr(i1,t1),pos_pr_ini,N_pr)
                    pos_pr_ini = pos_pr_ini+1
                    panel(i1,8,t1+1) = pos_pr_ini  
                end if
            elseif (panel(i1,2,t1) == 4) then !ERTE in W
                !no skill depreciation
                panel(i1,3,t1+1) = panel(i1,3,t1)
                panel(i1,4,t1+1) = panel(i1,4,t1)
                if (die(i1,t1)>mu) then !survives
                    !panel(i1,9,t1+1) = 1.d0
                    panel(i1,1,t1+1) = panel(i1,1,t1)
                    panel(i1,8,t1+1) = panel(i1,8,t1)
                    if (destruct(i1,t1) < delta(2)) then !exogenous job destruction and endogenous quitting
                        panel(i1,2,t1+1) = 0.d0 !become unemployed
                        panel(i1,5,t1+1) = 0.d0
                        call find_pos(prob_pr_birth_cum,shock_pr(i1,t1),pos_pr_ini,N_pr)
                        pos_pr_ini = pos_pr_ini+1
                        panel(i1,8,t1+1) = pos_pr_ini 
                    else !not exogenous destroyed or endogenous worker quitting
                        if (pol_RW_s(panel(i1,3,t1),panel(i1,4,t1),panel(i1,5,t1),panel(i1,8,t1),t1)==1) then !worker searches in W
                            panel(i1,10,t1) = 2.d0
                            if (offer(i1,t1)<p_W_RW(panel(i1,3,t1),panel(i1,4,t1),panel(i1,5,t1),panel(i1,8,t1),t1)) then !job offer
                                call find_pos(xi_prob_cum,offer_type_p(i1,t1),offer_type,N_xi)
                                offer_type = offer_type+1
                                if ((pol_RW_W(panel(i1,3,t1),panel(i1,4,t1),panel(i1,5,t1),panel(i1,8,t1),offer_type,t1)==1) .and. &
                                    (pol_F_fill_W(panel(i1,3,t1),panel(i1,4,t1),offer_type,panel(i1,8,t1),t1) == 1)) then !accepts outside offer and firm fills it
                                    panel(i1,2,t1+1) = 2.d0 !become employed
                                    xi_aux = Pxi_tran(offer_type,:)
                                    call find_pos(xi_aux,tran_xi(i1,t1),next_xi,N_xi)
                                    panel(i1,5,t1+1) = next_xi+1
                                    panel(i1,7,t1) = 1.d0
                                else !stays on current ERTE
                                    xi_aux = Pxi_tran(panel(i1,5,t1),:)
                                    call find_pos(xi_aux,tran_xi(i1,t1),next_xi,N_xi)
                                    panel(i1,5,t1+1) = next_xi+1
                                    if (pol_F_RW_W(panel(i1,3,t1),panel(i1,4,t1),panel(i1,5,t1),panel(i1,8,t1),t1)==0) then !firm does not recall worker
                                        panel(i1,2,t1+1) = 4.d0
                                    else !recalled
                                        panel(i1,2,t1+1) = 2.d0
                                    end if
                                end if
                            else !no job offer
                                xi_aux = Pxi_tran(panel(i1,5,t1),:)
                                call find_pos(xi_aux,tran_xi(i1,t1),next_xi,N_xi)
                                panel(i1,5,t1+1) = next_xi+1
                                if (pol_F_RW_W(panel(i1,3,t1),panel(i1,4,t1),panel(i1,5,t1),panel(i1,8,t1),t1)==0) then !firm does not recall worker
                                    panel(i1,2,t1+1) = 4.d0
                                else !recalled
                                    panel(i1,2,t1+1) = 2.d0
                                end if
                            end if
                        else !worker searches in H
                            panel(i1,10,t1) = 1.d0
                            if (offer(i1,t1)<p_H_RW(panel(i1,3,t1),panel(i1,4,t1),panel(i1,5,t1),panel(i1,8,t1),t1)) then !job offer
                                call find_pos(xi_prob_cum,offer_type_p(i1,t1),offer_type,N_xi)
                                offer_type = offer_type+1
                                if ((pol_RW_H(panel(i1,3,t1),panel(i1,4,t1),panel(i1,5,t1),panel(i1,8,t1),offer_type,t1)==1) .and. &
                                    (pol_F_fill_H(panel(i1,3,t1),panel(i1,4,t1),offer_type,panel(i1,8,t1),t1) == 1)) then !accepts outside offer and firm fills it
                                    panel(i1,2,t1+1) = 1.d0 !become employed
                                    xi_aux = Pxi_tran(offer_type,:)
                                    call find_pos(xi_aux,tran_xi(i1,t1),next_xi,N_xi)
                                    panel(i1,5,t1+1) = next_xi+1
                                    panel(i1,7,t1) = 1.d0
                                else !stays on current ERTE
                                    xi_aux = Pxi_tran(panel(i1,5,t1),:)
                                    call find_pos(xi_aux,tran_xi(i1,t1),next_xi,N_xi)
                                    panel(i1,5,t1+1) = next_xi+1
                                    if (pol_F_RW_W(panel(i1,3,t1),panel(i1,4,t1),panel(i1,5,t1),panel(i1,8,t1),t1)==0) then !firm does not recall worker
                                        panel(i1,2,t1+1) = 4.d0
                                    else !recalled
                                        panel(i1,2,t1+1) = 1.d0
                                    end if
                                end if
                            else !no job offer
                                xi_aux = Pxi_tran(panel(i1,5,t1),:)
                                call find_pos(xi_aux,tran_xi(i1,t1),next_xi,N_xi)
                                panel(i1,5,t1+1) = next_xi+1
                                if (pol_F_RW_W(panel(i1,3,t1),panel(i1,4,t1),panel(i1,5,t1),panel(i1,8,t1),t1)==0) then !firm does not recall worker
                                    panel(i1,2,t1+1) = 4.d0
                                else !recalled
                                    panel(i1,2,t1+1) = 2.d0
                                end if
                            end if
                        end if
                        
                    end if
                else !dies
                    count_H = count_H+1
                    panel(i1,1,t1+1) = count_H
                    panel(i1,2,t1+1) = 0.d0 !all start unemployed
                    !panel(i1,9,t1+1) = 1.d0 !all start allive
                    panel(i1,3,t1+1) = 1 !zero skills
                    panel(i1,4,t1+1) = 1
                    call find_pos(prob_pr_birth_cum,shock_pr(i1,t1),pos_pr_ini,N_pr)
                    pos_pr_ini = pos_pr_ini+1
                    panel(i1,8,t1+1) = pos_pr_ini  
                end if    
            end if
        !end if
    end do
end do
    
!call sub_mexWriteString('panel created')   
end subroutine



    
    
subroutine cumsum(vec_in,vec_out,n)
!performs cumsum on vector vec_in

!define in and outputs
integer(4), intent(in)	   :: n
real(8), intent(in)    :: vec_in(n)
real(8), intent(out)   :: vec_out(n)
integer(4)                :: i1

vec_out(1) = vec_in(1)
do i1 = 2,n
	vec_out(i1) = vec_out(i1-1)+vec_in(i1)
end do


end subroutine




subroutine find_pos(vec_in,sca,pos,n)
!finds sca on monotone vector vec_in (number of smaller points)

!define in and outputs
integer(4), intent(in)	   :: n
real(8), intent(in)    :: vec_in(n),sca
integer(4), intent(out)   :: pos
integer(4)                :: i1

pos = 0
do i1 = 1,n
	if (sca>vec_in(i1)) then
		pos = i1
	end if
	if (vec_in(i1)>=sca) exit
end do

end subroutine




subroutine lininter(x,y,n,x0,y0)

!Function lininter computes a linear interpolation for point x0
!given the vector of x-values in x and their corresponding funtional values y with length n

implicit none

!define in and outputs
integer(4), intent(in)                  :: n
real(8), intent(in)             		:: x(n),y(n)
real(8), intent(in)                     :: x0
real(8), intent(out)                    :: y0

!further variables 
integer(4)                                 :: j

!call locate(x,n,x0,j)
call find_pos(x,x0,j,n)

if (j==0) then
    j=1
elseif (j==n) then
    j=n-1
end if

y0 = y(j)+(y(j+1)-y(j))*(x0-x(j))/(x(j+1)-x(j));

end subroutine lininter

    
    
subroutine interp2(x,y,v,nx,ny,x0,y0,v0)

!Function lininter computes a 2D linear interpolation for point x0,y0
!given the vector of x and y-values in x and y and their 
!corresponding funtional values v 

implicit none

!define in and outputs
integer(4), intent(in)                  :: nx,ny
real(8), intent(in)             		:: x(nx),y(ny),v(nx,ny)
real(8), intent(in)                     :: x0,y0
real(8), intent(out)                    :: v0

!further variables 
integer(4)                                 :: jx,jy,n
real(8)                                 :: num,a00,a01,a10,a11

!call locate(x,n,x0,j)
call find_pos(x,x0,jx,nx)

if (jx==0) then
    jx=1
elseif (jx==nx) then
    jx=nx-1
end if

call find_pos(y,y0,jy,ny)

if (jy==0) then
    jy=1
elseif (jy==ny) then
    jy=ny-1
end if


num = ((x(jx+1)-x(jx))*(y(jy+1)-y(jy)))
a00 = ((x(jx+1)-x0)*(y(jy+1)-y0))/num
a01 = ((x(jx+1)-x0)*(y0-y(jy)))/num
a10 = ((x0-x(jx))*(y(jy+1)-y0))/num
a11 = ((x0-x(jx))*(y0-y(jy)))/num

v0 = a00*v(jx,jy)+a01*v(jx,jy+1)+a10*v(jx+1,jy)+a11*v(jx+1,jy+1)

end subroutine interp2
    
    
    
subroutine interp3(x,y,z,v,nx,ny,nz,x0,y0,z0,v0)
!Function interp3 computes a 3D linear interpolation for point x0,y0,z0
!given the vector of x, y and z-values in x and y and their 
!corresponding funtional values v 

implicit none

!define in and outputs
integer(4), intent(in)                  :: nx,ny,nz
real(8), intent(in)             		:: x(nx),y(ny),z(nz),v(nx,ny,nz)
real(8), intent(in)                     :: x0,y0,z0
real(8), intent(out)                    :: v0

!further variables 
integer(4)                              :: jx,jy,jz,n
real(8)                                 :: num,a000,a001,a010,a011
real(8)                                 :: a100,a101,a110,a111



call find_pos(x,x0,jx,nx)

if (jx==0) then
    jx=1
elseif (jx==nx) then
    jx=nx-1
end if

call find_pos(y,y0,jy,ny)

if (jy==0) then
    jy=1
elseif (jy==ny) then
    jy=ny-1
end if


call find_pos(z,z0,jz,nz)

if (jz==0) then
    jz=1
elseif (jz==nz) then
    jz=nz-1
end if


num = ((x(jx+1)-x(jx))*(y(jy+1)-y(jy))*(z(jz+1)-z(jz)))

a000 = ((x(jx+1)-x0)*(y(jy+1)-y0)*(z(jz+1)-z0))/num
a001 = ((x(jx+1)-x0)*(y(jy+1)-y0)*(z0-z(jz)))/num
a010 = ((x(jx+1)-x0)*(y0-y(jy))*(z(jz+1)-z0))/num
a011 = ((x(jx+1)-x0)*(y0-y(jy))*(z0-z(jz)))/num
a100 = ((x0-x(jx))*(y(jy+1)-y0)*(z(jz+1)-z0))/num
a101 = ((x0-x(jx))*(y(jy+1)-y0)*(z0-z(jz)))/num
a110 = ((x0-x(jx))*(y0-y(jy))*(z(jz+1)-z0))/num
a111 = ((x0-x(jx))*(y0-y(jy))*(z0-z(jz)))/num


v0 = a000*v(jx,jy,jz)+a001*v(jx,jy,jz+1)+a010*v(jx,jy+1,jz)+a011*v(jx,jy+1,jz+1) &
        +a100*v(jx+1,jy,jz)+a101*v(jx+1,jy,jz+1)+a110*v(jx+1,jy+1,jz)+a111*v(jx+1,jy+1,jz+1)
        
end subroutine interp3
    

    
    
    
subroutine max_int(int_out,int1,int2)

!max of integer

implicit none

!define in and outputs
integer, intent(in)						:: int1,int2
integer, intent(out)                    :: int_out


if (int1>=int2) then
    int_out = int1
else
    int_out = int2
end if

end subroutine max_int


subroutine sub_mexWriteString(String)
  implicit none
  character(*),intent(in):: String
  call mexPrintf(achar(10))
  call mexPrintf(trim(adjustl(String)))
end subroutine sub_mexWriteString